import { Vector3, distance, distanceSquared, cross } from "./vector3";
import * as game from "./game";

export async function onScriptEventReceive(event) {

    const book = event.sourceEntity;
    if (event.id === "tcs_mbh:open_book")
    {
        const player = (await game.getPlayerInLocation(book.dimension, book.location))[0];
        if (!player.hasTag("tcs_mbh_book_viewed"))
        {
            player.addTag("tcs_mbh_book_viewed");
			// game.runPlayerCommand(player, `structure load tcs_mbh:welcome_items ~ ~ ~`);
			game.runPlayerCommand(player, `loot spawn ~ ~ ~ loot "tcs/mbh/starting_items"`);
            await game.tellraw(player, "@s", "§l§aWelcome to Mob Heads Add-On§f");
            //player.dimension.spawnEntity("tcs_mbh:celebration_fx", player.location);
        }
        return;
    }

    // book entity hurt by player
    const player = (await game.getPlayerInLocation(book.dimension, book.location))[0];

    const hitDistance = distance(book.location, player.location);
    const lookDirection = new Vector3(player.getViewDirection());
    const hitPoint = lookDirection.multiply(hitDistance).add(player.location);

    const right = cross(book.getViewDirection(), {x: 0, y: 1, z: 0});
    const rightPoint = new Vector3(book.location).add(right);
    const leftPoint = new Vector3(book.location).subtract(right);
    if(distanceSquared(rightPoint, hitPoint) < distanceSquared(leftPoint, hitPoint)) {
        book.triggerEvent("tcs_mbh:turn_page_left");
    } else {
        book.triggerEvent("tcs_mbh:turn_page_right");
    }
}
