import { world, system, EquipmentSlot } from "@minecraft/server";
import * as mob_head from "./mob_head";
import * as book from "./book";
import * as game from "./game";

export async function onLoadFirstTime() {
	
}

export async function onLoad() {
}

export async function onTick() {
	await mob_head.onTick();
}


export async function onPlayerSpawn(event) {
	//await info_book.onPlayerSpawn(event);

}


export async function onItemUse(event) {
	
	await mob_head.onItemUse(event);
	
	let itemTypeId = event.itemStack.typeId;
	// if (itemTypeId === "tcs_mbh:book")
	// 	await book.onItemUse(event);

	/*if (itemTypeId === "tcs_mbh:starter_kit"){
		let player = event.source;
		game.runPlayerCommand(player, `clear @s tcs_mbh:starter_kit 0 1`);
		game.runPlayerCommand(player, `playsound tcs_mbh:reward @s ~ ~ ~ 100 1 1`);
		//game.runPlayerCommand(player, `particle tcs_mbh:open_starter_kit ~ ~ ~`);
		//game.runPlayerCommand(player, `particle tcs_mbh:open_starter_kit_2 ~ ~ ~`);
		game.runPlayerCommand(player, `structure load tcs_mbh:starter_kit_loot ~ ~ ~`);
		game.actionbar(player, "@s", `§aCongratulations - you got the starter kit!`);
	}*/	
}

export async function onEntityDie(event) {
	await mob_head.onEntityDie(event);
}

export async function onEntityHurt(event) {
	await mob_head.onEntityHurt(event);
}
export async function onProjectileHitBlock(event) {
	await mob_head.onProjectileHitBlock(event);
}
export async function onEffectAdd(event) {
	await mob_head.onEffectAdd(event);
}
export async function onScriptEventReceive(event) {
	if (event.id === "tcs_mbh:hit_book" || event.id === "tcs_mbh:open_book")
       book.onScriptEventReceive(event);
}







export async function onPlayerPlaceBlock(event) {
	const block = event.block;
	if (block.typeId.startsWith("tcs_mbh:") && block.typeId.endsWith("_head_block")) {

		// Play custom particle for block placement
		world.getDimension("overworld").spawnParticle(
			"tcs_mbh:place_head",
			block.location
		);

		// Play custom sound for block placement
		world.getDimension("overworld").playSound(
			"tcs_mbh:place_head",
			block.location,
			{
				pitch: 1.0,
				volume: 1.0,
			}
		);
	}
}

let brokenBlocks = new Map();

export async function onPlayerBreakBlockBefore(event) {
	
	let block = event.block;
	let player = event.player;

	if (block.typeId.startsWith("tcs_mbh:") && block.typeId.endsWith("_head_block")) {
		// Store block data temporarily
        brokenBlocks.set(player.name, {
            typeId: block.typeId,
            location: block.location,
        });
	}
}
export async function onPlayerBreakBlockAfter(event) {
	let player = event.player;
	let brokenBlocksData = brokenBlocks.get(player.name);
	
	if (brokenBlocksData) {
        const { typeId, location } = brokenBlocksData;
		// Play custom particle for block breaking
		world.getDimension("overworld").spawnParticle(
			"tcs_mbh:remove_head",
			location
		);

		// Play custom sound for block breaking
		world.getDimension("overworld").playSound(
			"tcs_mbh:remove_head",
			location,
			{
				pitch: 1.0,
				volume: 1.0,
			}
		);

		// Clean up the temporary data
        brokenBlocks.delete(player.name);
	}
}