import { ItemStack, EquipmentSlot, EnchantmentType, EntityComponentTypes, ItemLockMode } from "@minecraft/server";
import * as heads from "./heads";


async function isWearingMobHead(player, itemName)
{
	const equipment = player.getComponent("equippable");
	let item = await equipment.getEquipment("Head");
	if (item === undefined) return false;
	if (item.typeId === itemName) return true;
	return false;
}
export function getHelmet(entity)
{
	if (entity === undefined || entity.typeId !== "minecraft:player")
		return undefined;
	const equipment = entity.getComponent("equippable");
	let item = equipment.getEquipment("Head");
	if (item === undefined) return undefined;
	return item.typeId;
}

export async function drainMobHeadDurability(player, mobHeadData)
{
	const equipment = player.getComponent("equippable");
	let mobHead = equipment.getEquipment("Head");
	let newMobHead = damageArmorItem(mobHead, mobHeadData.useCost, mobHeadData.durability);
	equipment.setEquipment("Head", newMobHead);
}
function damageArmorItem(armorItem, damage, maxDurabity)
{
	if (armorItem == undefined)
		return undefined;
	let newArmorItem = new ItemStack(armorItem.typeId);
	newArmorItem.lockMode = armorItem.lockMode;
	
	let newDamage = armorItem.getComponent("durability").damage;
	newDamage = newDamage ? (newDamage+damage) : damage;
	
	if (newDamage >= maxDurabity)
		newArmorItem = undefined;
	else
		newArmorItem.getComponent("durability").damage = newDamage;
	return newArmorItem;
}

export async function countItemInInventory(player, itemTypeId)
{
	const inventory = player.getComponent("minecraft:inventory").container;
	let itemCount = 0;
	for (let i = 0; i < inventory.size; i++) {
		let item = inventory.getItem(i);
		if (item !== undefined && item.typeId === itemTypeId)
			itemCount += item.amount;
	}
	return itemCount;
}
